/*
IDE defs
*/

#ifndef ___IDE_H
#define ___IDE_H

// functions
void ide_init( void);
void ide_hreset(void);
void ide_soft_reset( void);
//unsigned char ide_read_b( unsigned char * addr);
//void ide_write_b( unsigned char * addr, unsigned char value);

void dump_ide_reg( void);



//definitions
#define	DATA_H		(volatile unsigned char *)0xC000

#if MINIMEGAHMPEG == FALSE	// Hmpeg
	#define	IDE_RESET	4			/* bit 4 , port D */
#else	// MiniMegaHmpeg
	#define	IDE_RESET	5			/* bit 5 , port D */
#endif

#define CB_DATA  (volatile unsigned char *)0x8000   /* data reg         in/out */
#define CB_ERR   (volatile unsigned char *)0x8001   /* error            in		*/
#define CB_FR    (volatile unsigned char *)0x8001   /* feature reg         out	*/
#define CB_SC    (volatile unsigned char *)0x8002   /* sector count     in/out	*/
#define CB_SN    (volatile unsigned char *)0x8003   /* sector number    in/out	*/
#define CB_CL    (volatile unsigned char *)0x8004   /* cylinder low     in/out	*/
#define CB_CH    (volatile unsigned char *)0x8005   /* cylinder high    in/out	*/
#define CB_DH    (volatile unsigned char *)0x8006   /* device head      in/out	*/
#define CB_STAT  (volatile unsigned char *)0x8007   /* primary status   in		*/
#define CB_CMD   (volatile unsigned char *)0x8007   /* command             out	*/
#define CB_ASTAT (volatile unsigned char *)0xA006   /* alternate status in		*/
#define CB_DC    (volatile unsigned char *)0xA006   /* device control      out	*/

//defs for LBA
#define LBA_8	CB_SN
//bits 15-8
#define LBA_16	CB_CL
//bits 16-23
#define LBA_23	CB_CH
//bits 24-27
#define LBA_27	CB_DH

/* error reg (CB_ERR) bits */

#define CB_ER_ICRC 0x80    /* ATA Ultra DMA bad CRC */
#define CB_ER_BBK  0x80    /* ATA bad block */
#define CB_ER_UNC  0x40    /* ATA uncorrected error */
#define CB_ER_MC   0x20    /* ATA media change */
#define CB_ER_IDNF 0x10    /* ATA id not found */
#define CB_ER_MCR  0x08    /* ATA media change request */
#define CB_ER_ABRT 0x04    /* ATA command aborted */
#define CB_ER_NTK0 0x02    /* ATA track 0 not found */
#define CB_ER_NDAM 0x01    /* ATA address mark not found */

#define CB_ER_P_SNSKEY 0xf0   /* ATAPI sense key (mask) */
#define CB_ER_P_MCR    0x08   /* ATAPI Media Change Request */
#define CB_ER_P_ABRT   0x04   /* ATAPI command abort */
#define CB_ER_P_EOM    0x02   /* ATAPI End of Media */
#define CB_ER_P_ILI    0x01   /* ATAPI Illegal Length Indication */

/* ATAPI Interrupt Reason bits in the Sector Count reg (CB_SC) */

#define CB_SC_P_TAG    0xf8   /* ATAPI tag (mask) */
#define CB_SC_P_REL    0x04   /* ATAPI release */
#define CB_SC_P_IO     0x02   /* ATAPI I/O */
#define CB_SC_P_CD     0x01   /* ATAPI C/D */

/* bits 7-4 of the device/head (CB_DH) reg */

#define CB_DH_DEV0 0xe0   /* select device 0 */
#define CB_DH_DEV1 0xf0   /* select device 1 */

/* status reg (CB_STAT and CB_ASTAT) bits */

#define CB_STAT_BSY  0x80  /* busy */
#define CB_STAT_RDY  0x40  /* ready */
#define CB_STAT_DF   0x20  /* device fault */
#define CB_STAT_WFT  0x20  /* write fault (old name) */
#define CB_STAT_SKC  0x10  /* seek complete */
#define CB_STAT_SERV 0x10  /* service */
#define CB_STAT_DRQ  0x08  /* data request */
#define CB_STAT_CORR 0x04  /* corrected */
#define CB_STAT_IDX  0x02  /* index */
#define CB_STAT_ERR  0x01  /* error */

/* digital output reg (CB_DC) bits */

#define CB_DC_HD15   0x08  /* bit should always be set to one */
#define CB_DC_SRST   0x04  /* soft reset */
#define CB_DC_NIEN   0x02  /* disable interrupts */

#endif
