/*
ISO9660 stuff

License : GPL
(c) Adam Majerczyk
*/

#include "my_defs.h"
#include "memory.h"
#include "serial.h"
#include "tools.h"

#include "ide.h"
#include "atapi.h"
#include "iso9660.h"
#include "mas.h"
#include "lcd.h"

extern struct read_file *play_cmd;
extern unsigned char ERRNO;
extern unsigned char player_status;
extern unsigned short song_num;
extern unsigned char ST_REG;

//reads CD title
void cd_info( unsigned char iso)
{
	unsigned char dummy, idx;

	clr_cmd();
	cmd[0] = CMD_READ_12;

	cmd[5]= (iso == 0) ? JOLIET_BOOT_BLOCK : ISO_BOOT_BLOCK;
	cmd[9] = 0x01;

	atapi_cmd(atapi_buffer);
	if( ERRNO == NO_ERROR)
	{
		idx = iso==1?0:1;
		for( dummy=0 ; dummy < CD_TITLE_SIZE; dummy++ )
		{
			cd_title[dummy] = atapi_buffer[ISO_VOL_ID + idx++];
			if( iso == 0)	idx++;
		}
	}
}

int dir_cd( void)
{
	unsigned char dummy, tmp,iso9660;
	unsigned short idx,temp;
	unsigned long *long_ptr;
	unsigned char *cmd = (unsigned char *)CD_CMD_ADR;

	iso9660=0;
	clr_cmd();
	cmd[0] = CMD_READ_12;
	cmd[5] = JOLIET_BOOT_BLOCK;
	cmd[9] = 0x01;

iso_try:

	if( atapi_cmd(atapi_buffer) == 0)	return 1;
	long_ptr = (unsigned long *)&atapi_buffer[0x9c + 0x02];		//get root record

	if( *long_ptr == 0)
	{
		lcd_print("ISO");
		delay_ms(1000);
		if(iso9660 == 0)
		{
			iso9660 = 1;
			cmd[5] = ISO_BOOT_BLOCK;
			goto iso_try;
		}
		else
		{
			return 1;
		}
	}

	cd_info(iso9660);
	cmd[5] = *long_ptr;	

	dir_count = 0;
	temp = 0;

	while(1)
	{
		if( atapi_cmd(atapi_buffer) == 0)		return 1;

		dummy = atapi_buffer[0]; 						//get len 1. record
		if(dummy <= 2) break;

		idx	= (*dir_count == 0) ? atapi_buffer[dummy] + dummy : 0

		while( (atapi_buffer[idx] != 0) && (idx < 0x0800))				// memory loop 
		{
			for(dummy = 0; dummy <4; dummy++)
			{
				dir_buffer[temp++] =  atapi_buffer[idx +2 + dummy];		//first block
			}

			dummy = 10;
			while( dummy < 14)
			{
				dir_buffer[temp++] = atapi_buffer[idx + dummy++];
			}

			for( dummy = 0; dummy < atapi_buffer[idx +32] ; dummy++)	//name
			{
				if( iso9660 == 0)		dummy++;

				tmp = atapi_buffer[idx + 33 + dummy];

				if( tmp == ';') break;
				dir_buffer[temp] = tmp;	//save character
				temp++;
			}

			//if last entry=dir -> ente;
			if( tmp != ';')
			{
				if( iso9660 == 1)
				{
					temp = temp - dummy;
				}
				else
				{
					temp = temp - (dummy /2);
				}
				temp = temp - 8;
				break;
			}

			//strip extension
			if( dir_buffer[temp -4 ] == '.')
			{
				temp = temp -4;
			}
			dir_buffer[temp++] = 0x00;
			dir_count = dir_count +1;
			idx = idx + atapi_buffer[idx];
		}
		cmd[5] += 1;								//BUG!!!!!!!!! byte only !
	}

	for(dummy = 0; dummy <4; dummy++)
	{
		dir_buffer[temp++] = 0x00;
	}
	return 0;
}

unsigned long to_bendian( unsigned long l_in)
{
	unsigned long l_out;
/*
	78 56 34 12
	12 34 56 78
*/
	l_out =  l_in << 24;
	l_out |= ( l_in & 0xff00) << 8;
	l_out |= ( l_in & 0xff0000) >> 8;
	l_out |= l_in >> 24;
	return l_out;
}

//updates play buffer
//reads 4 blocks!!!!
//returns bytes readen
void update_buf_cd(unsigned char *buffer)
{
	unsigned short bytes_read=0;
	unsigned short temp;
	unsigned char dummy;

	//fill buffer
	for(dummy = 0; dummy <(PLAY_BUFFER_SIZE / 0x800); dummy++)
	{
		temp =atapi_cmd( buffer + (dummy * 0x800));
		if( ERRNO != NO_ERROR)
		{
			ST_REG = 0;
			return 0;
		}
		bytes_read = bytes_read + temp;
		NextBlock = to_bendian(to_bendian(NextBlock)+1);		//next block 
	}
}

