#ifndef __MAS_H
#define __MAS_H

/**************************************************
functions
*/

extern unsigned long read_reg ( unsigned char reg);
extern void write_reg( unsigned char reg, unsigned long data);
extern unsigned short default_read( void);

extern unsigned char _local_buffer[6];

#define		MEM_D0	0xE0
#define		MEM_D1	0xF0

extern unsigned long mas_read_mem( unsigned char mem, unsigned short addr);
extern void mas_write_mem( unsigned char mem, unsigned short addr, unsigned long data);

extern void mas_run( unsigned short addr);

extern void mas_init ( void);
extern void mas_info( void);

/**************************************************
definitions
*/

/*
	MAS I2C	defs
*/
#define MAS_ADR			0x3a
#define	MAS_DEV_WRITE	0x3a
#define	MAS_DEV_READ	0x3b

/* registers..*/
#define	MAS_DATA_WRITE	0x68
#define MAS_DATA_READ	0x69
#define	MAS_CONTROL		0x6a

/*
	MAS register
*/

#define	MAS_REG_DCCF			0x8e
#define	MAS_REG_MUTE			0xaa
#define	MAS_REG_PIODATA			0xc8
#define	MAS_REG_StartUpConfig	0xe6
#define	MAS_REG_KPRESCALE		0xe7
#define	MAS_REG_KBASS			0x6b
#define	MAS_REG_KTREBLE			0x6f


#endif
