 
#include <io.h>
#include <interrupt.h>
#if __GNUC__ == 2
	#include <signal.h>
#else
	#include <sig-avr.h>
#endif
#include <progmem.h>

#include "my_defs.h"
#include "serial.h"

void sendstring( char * string)
{
	while (*string !=0)	
	{	
		putchar(*(string++));
	}
}

#if DEBUG == TRUE
void sendstring_( char * string)
{
	while (PRG_RDB(string) !=0)	
	{	
		putchar(PRG_RDB(string++));
	}
}
#endif

void putchar (unsigned char u)
{	loop_until_bit_is_set(USR,UDRE);	//wait for end of last transmission
	outp(u, UDR);
}

void putlong (unsigned long u)
{	
	putchar(u);
	putchar(u >> 8);
	putchar(u >> 16);
	putchar(u >> 24);
	putchar(' ');
}


void new_line( void)
{
	sendstring("\r\n");
}
