#ifndef ___SERIAL_H
#define ___SERIAL_H

void sendstring( char * string);
void sendstring_( char * string);
void new_line( void);
void putchar (unsigned char);
void putlong(unsigned long);


#define EEPROM_SIZE (E2END+1)

// Baudrate Berechnung
#define UART_BAUD_1 (F_CPU/(UART_BAUD_RATE*16L)-1)				// Baudrate Selektor, ohne Nachkommateil
#define UART_BAUD_1000 (F_CPU /(UART_BAUD_RATE*16L /1000)-1000)	// Zwischenrechnung...
#if (UART_BAUD_1000 - (UART_BAUD_1 * 1000L)) >= 500				// ab .5
	#define UART_BAUD_SELECT	(UART_BAUD_1 + 1)				// aufrunden
#else
	#define UART_BAUD_SELECT	(UART_BAUD_1)					// sonst nicht aufrunden
#endif

// ungnstige Baudraten erkennen
#define UART_BAUD_ERROR ((UART_BAUD_1000 - UART_BAUD_SELECT * 1000L) \
        * 1000L / UART_BAUD_1000)								// Fehler der Baudrate in Promille

#if (UART_BAUD_ERROR > 20) || (UART_BAUD_ERROR < -20)			// mehr als 2 % Abweichung: Fehler
	#error Die gewaehlte Baudrate funktioniert nicht mit der aktuellen Quarzfrequenz (Fehler > 2 %)
#elif (UART_BAUD_ERROR > 10) || (UART_BAUD_ERROR < -10)			// mehr als 1 % Abweichung: Warnung
	#warning Die gewaehlte Baudrate ist nicht optimal (Fehler > 1 %)
#endif


#endif
