#include <io.h>
#include <timer.h>

#include "my_defs.h"
#include "tools.h"
#include "serial.h"
//#include "memory.h"

// Zeitkonstanten in Abhngigkeit der Quarzfrequenz
#define DELAY1MS		(31 * F_CPU / 8000000)

unsigned char inline lnibble_to_hex( unsigned char zeichen)
{
	zeichen = zeichen & 0x0F;
	if( zeichen < 10)
		{
			zeichen += '0';
		}
		else
		{
			zeichen +=  'A' - 10 ;
		}
	return zeichen;
}

void delay_ms (unsigned int count)
{
	while (count--)
	{
		TIMER8BIT_START;
		while(TIMER8BIT_CNT < DELAY1MS);
	}
}

void print_long( unsigned long wert)
{
	char dummy;

	for(dummy = 28; dummy >= 0; dummy =dummy-4)
	{
  		putchar (lnibble_to_hex( wert >> dummy));
	}
	putchar(' ');
}

void ws_strncpy(unsigned char * dst, unsigned int * src, unsigned char count)
{
	while(count--)
//		if (0xff == (*(dst++) = *(src++))) break;
		*(dst++) = *(src++);		
	*dst = 0x00;
}


#if DEBUG == TRUE
void dump_mem( unsigned char * start_adr)
{
	unsigned char i;
	unsigned char wert;
	unsigned char buffer[7];

	sendstring((char *)word_to_hex( (unsigned short)start_adr));
	sendstring(":  ");

	buffer[2] = ' ';
	buffer[3] = 0x00;

	for( i = 0; i<= 15; i++)
	{
		buffer[0] = lnibble_to_hex( start_adr[i] >>4 );
		buffer[1] = lnibble_to_hex( start_adr[i]);

		sendstring(buffer);
	}

	for( i = 0; i<= 15; i++)
	{
		wert = start_adr[i];
		if( wert >= 32 && wert < 125)
		{
			buffer[0] = wert;
		}
		else
			{
				buffer[0] = '.';
			}
		buffer[1] = 0x00;
		sendstring(buffer);
	}
}

void show_mem( unsigned char *start, unsigned char *end)
{
	unsigned char *ptr;

	ptr = start;
	while( ptr < end)
	{
		dump_mem( ptr);
		new_line();
		ptr = ptr +16;
	}

}

static unsigned char __convert_buffer[7];

/////////////////////////////////////////
unsigned char * byte_to_hex( unsigned char value)
{
//	unsigned char buffer[3];
	unsigned char dummy;

	dummy = lnibble_to_hex( value>>4);
	__convert_buffer[0] = dummy;

	dummy = lnibble_to_hex( value);
	__convert_buffer[1] = dummy;
	dummy = 0;
	__convert_buffer[2] = dummy;
	return __convert_buffer;
}


/////////////////////////////////////////
unsigned char * word_to_hex( unsigned short adr)
{
	char dummy;
	unsigned char i;

	i=0;
	for(dummy =12; dummy >=0; dummy = dummy -4)
	{
		__convert_buffer[i++] = lnibble_to_hex( (unsigned short)adr>> dummy);
	}
	__convert_buffer[i] = 0x00;
	return __convert_buffer;
}

unsigned char * long_to_hex( unsigned long adr)
{
	char dummy;
	unsigned char i;

	i=0;
	for(dummy =28; dummy >=0; dummy = dummy -4)
	{
		__convert_buffer[i++] = lnibble_to_hex( (unsigned long)adr>> dummy);
	}
	__convert_buffer[i] = 0x00;
	return __convert_buffer;
}


/////////////////////////////////////////
void print_short( unsigned short wert)
{
	sendstring( byte_to_hex( wert >>8) );
	sendstring( byte_to_hex( wert ));
}


/////////////////////////////////////////
void print_short_dec (unsigned short wert)
{

	unsigned char i;
	unsigned short dummy;
	static unsigned char zahl[7];

	i = 0;
	for( dummy = 10000; dummy !=0; dummy =dummy / 10)
	{
		zahl[i] = (wert / dummy) + 48;
		wert = wert % dummy;
		i++;
	}

	zahl[i] = 0;
	sendstring(&zahl[0]);
}

/////////////////////////////////////////

unsigned char * short_to_dec (unsigned short wert)
{
	unsigned char i,x;
	unsigned short dummy;
	static unsigned char zahl[6];

	i = 0;
	x = 0;
	for( dummy = 10000; dummy !=0; dummy =dummy / 10)
	{
		if( (x == 0) && ((wert / dummy)> 0) )
		{
			x = 1;
		}
		if( x > 0)
		{
			zahl[i] = (wert / dummy) + 48;
			i++;
		}
		wert = wert % dummy;
	}

	zahl[i] = 0;
	return zahl;
}

void print_byte_dec( unsigned char wert)
{

	unsigned char i;
	unsigned short dummy;
	unsigned char zahl[4];

	i = 0;
	for( dummy = 100; dummy !=0; dummy =dummy / 10)
	{
		zahl[i] = (wert / dummy) + 48;
		wert = wert % dummy;
		i++;
	}

	zahl[i] = 0;
	sendstring(&zahl[0]);

}

unsigned char * byte_to_dec( unsigned char wert, unsigned char flag)
{

	unsigned char i,x;
	unsigned char dummy;
	static unsigned char zahl[4];

	i = 0;
	for( dummy = 100; dummy !=0; dummy =dummy / 10)
	{
		x = (wert / dummy) ;
		wert = wert % dummy;
		if( (x != 0) && (flag == 0) ) flag = 1;
		if( flag == 1)
		{
			zahl[i] = x+48;
			i++;
		}												   
	}

	if(i == 0)
	{
		zahl[i++] = '0';
	}
	zahl[i] = 0;
	return zahl;
}
											   
unsigned short strtoshort( unsigned char *title_num)
{
	unsigned char len;
	unsigned short value=0;
	unsigned short multi=1;

	len = strlen(title_num);
										   			    
	if(len == 0) return 0;		    

	len = len -1;
	while(len > 0)
	{
		value = value + (multi * (title_num[len]-48));
		multi= multi * 10;
		len--;
	}
	value = value + (multi * (title_num[len]-48));

	return value;
}



//Kopiert String in 16bit nach 8bit (fuer Dir)
#if 0
unsigned char ws_strncpy(unsigned char * dst, unsigned char * src, unsigned char count)
{
	unsigned char x,y;

	x=0;
	y=0;

	while( (src[x] != 0xFF) && (src[x] != 0) && ( y < count))
	{
		dst[y] = src[x];
		x++;
		x++;
		y++;
	}
	dst[y++] = 0x00;
	return y;
}

#endif


unsigned long to_bendian( unsigned long l_in)
{
	unsigned long l_out=0;
/*
	78 56 34 12
	12 34 56 78
*/
	l_out = (l_in & 0xff) << 24;
	l_out = l_out | (( l_in & 0xff00) << 8);
	l_out = l_out | (( l_in & 0xff0000) >> 8);
	l_out = l_out | (( l_in & 0xff000000) >> 24);
	return l_out;

}

unsigned short w_to_bendian( unsigned short l_in)
{
	unsigned short l_out=0;
/*
	78 56 34 12
	12 34 56 78
*/
	l_out = (l_in & 0xff) << 8;
	l_out = l_out | (( l_in & 0xff00)>>8);
	return l_out;

}

#endif
